####################################################################
#Office 365 for Labtech Plugin script
#This script should not be used outside the plugin
#
#Author: Shannon Anderson
#Date: 04/20/2016
#Site: www.plugins4labtech.com
#Version: 2.0.3
#
###################################################################
Param(
	[Parameter(Position=0, Mandatory=$true, ValueFromPipeline=$true)]
    [string] $Office365Username,
	[Parameter(Position=1, Mandatory=$true, ValueFromPipeline=$true)]
    [string] $Office365Password,
    [Parameter(Position=2, Mandatory=$true, ValueFromPipeline=$true)]
    [string] $ClientID
)
import-module MSOnline
Function Main {
	Get-PSSession | Remove-PSSession
	ConnectTo-ExchangeOnline -Office365AdminUsername $Office365Username -Office365AdminPassword $Office365Password -ea silentlyContinue -WarningAction silentlyContinue
	$password = ConvertTo-SecureString $Office365Password -AsPlainText -Force
	$credential = New-Object System.Management.Automation.PsCredential($Office365Username,$password)
	$cred = Get-Credential -cred $credential
	Connect-Msolservice -cred $cred
	$objUsers = get-MsolUser -All  -ea silentlyContinue -WarningAction silentlyContinue | select *
	Write-Output "DELETE FROM `plugin_sw_office365forlabtech_users` WHERE ClientID = $ClientID ;INSERT IGNORE INTO `plugin_sw_office365forlabtech_users`(`ClientID`,`UserPrincipalName`,`FirstName`,`LastName`,`DisplayName`,`UsageLocation`,`Department`,`Title`,`ProxyAddresses`,`LiveId`,`MobilePhone`,`PhoneNumber`,`IsLicensed`,`Licenses`,`StreetAddress`,`City`,`State`,`PostalCode`,`Office`,`ValidationStatus`,`OverallProvisioningStatus`,`AlternateEmailAddresses`,`AlternateMobilePhones`,`AlternativeSecurityIds`,`BlockCredential`,`Fax`,`IsBlackberryUser`,`LastDirSyncTime`,`LastPasswordChangeTimestamp`,`LicenseReconciliationNeeded`,`MSExchRecipientTypeDetails`,`PasswordNeverExpires`,`ServiceInformation`,`SignInName`,`SoftDeletionTimestamp`,`StrongPasswordRequired`,`UserLandingPageIdentifierForO365Shell`,`UserType`,`WhenCreated`) VALUES "
	$i = 0
	Foreach ($objUser in $objUsers)
	{
		$strUserPrincipalName = if ($objUser.UserPrincipalName){if($objUser.UserPrincipalName -contains "'"){$objUser.UserPrincipalName.Replace("'","''")}else{$objUser.UserPrincipalName.Replace("","''")}}else{$objUser.UserPrincipalName}
		$strFirstName = if ($objUser.FirstName){if($objUser.FirstName -contains "'"){$objUser.FirstName.Replace("'","''")}else{$objUser.FirstName.Replace("","''")}}else{$objUser.FirstName}
        $strLastName = if ($objUser.LastName){if($objUser.LastName -contains "'"){$objUser.LastName.Replace("'","''")}else{$objUser.LastName.Replace("","''")}}else{$objUser.LastName}
        $strDisplayName = if ($objUser.DisplayName){if($objUser.DisplayName -contains "'"){$objUser.DisplayName.Replace("'","''")}else{$objUser.DisplayName.Replace("","''")}}else{$objUser.DisplayName}
		$strUsageLocation = if ($objUser.UsageLocation){$objUser.UsageLocation.Replace("'","''")}else{$objUser.UsageLocation}
		$strDepartment = if ($objUser.Department){$objUser.Department.Replace("'","''")}else{$objUser.Department}
		$strTitle = if ($objUser.Title){$objUser.Title.Replace("'","''")}else{$objUser.Title}
		$strProxyAddress = $objUser.ProxyAddress
		$strLiveId = $objUser.LiveId
		$strMobilePhone = $objUser.MobilePhone
		$strPhoneNumber = $objUser.PhoneNumber
		$strIsLicensed = $objUser.IsLicensed
		$strLicenses = $objUser.Licenses
		$strStreetAddress = if ($objUser.StreetAddress){$objUser.StreetAddress.Replace("'","''")}else{$objUser.StreetAddress}
		$strState = $objUser.State
		$strCity = $objUser.City
		$strPostalCode = $objUser.PostalCode
		$strOffice = if ($objUser.Office){$objUser.Office.Replace("'","''")}else{$objUser.Office}
		$strValidationStatus = $objUser.ValidationStatus
		$strOverallProvisioningStatus = $objUser.OverallProvisioningStatus
		$strAlternateEmailAddresses = $objUser.AlternateEmailAddresses
		$strAlternateMobilePhones = $objUser.AlternateMobilePhones
		$strAlternativeSecurityIds = $objUser.AlternativeSecurityIds
		$strBlockCredential = $objUser.BlockCredential
		$strFax = $objUser.Fax
		$strIsBlackberryUser = $objUser.IsBlackberryUser
		$strLastDirSyncTime = $objUser.LastDirSyncTime
		$strLastPasswordChangeTimestamp = $objUser.LastPasswordChangeTimestamp
		$strLicenseReconciliationNeeded = $objUser.LicenseReconciliationNeeded
		$strMSExchRecipientTypeDetails = $objUser.MSExchRecipientTypeDetails
		$strPasswordNeverExpires = $objUser.PasswordNeverExpires
		$strServiceInformation = $objUser.ServiceInformation
		$strSignInName = $objUser.SignInName
		$strSoftDeletionTimestamp = $objUser.SoftDeletionTimestamp
		$strStrongPasswordRequired = $objUser.StrongPasswordRequired
		$strUserLandingPageIdentifierForO365Shell = $objUser.UserLandingPageIdentifierForO365Shell
		$strUserType = $objUser.UserType
		$strWhenCreated = $objUser.WhenCreated

        if($i -eq 0){
		Write-Output "($ClientID, '$strUserPrincipalName', '$strFirstName', '$strLastName', '$strDisplayName', '$strUsageLocation', '$strDepartment', '$strTitle', '$strProxyAddress', '$strLiveId', '$strMobilePhone', '$strPhoneNumber', '$strIsLicensed', '$strLicenses', '$strStreetAddress', '$strCity', '$strState', '$strPostalCode', '$strOffice', '$strValidationStatus', '$strOverallProvisioningStatus', '$strAlternateEmailAddresses','$strAlternateMobilePhones','$strAlternativeSecurityIds','$strBlockCredential','$strFax','$strIsBlackberryUser','$strLastDirSyncTime','$strLastPasswordChangeTimestamp','$strLicenseReconciliationNeeded','$strMSExchRecipientTypeDetails','$strPasswordNeverExpires','$strServiceInformation','$strSignInName','$strSoftDeletionTimestamp','$strStrongPasswordRequired','$strUserLandingPageIdentifierForO365Shell','$strUserType','$strWhenCreated')"
              }else{
		Write-Output ",($ClientID, '$strUserPrincipalName', '$strFirstName', '$strLastName', '$strDisplayName', '$strUsageLocation', '$strDepartment', '$strTitle', '$strProxyAddress', '$strLiveId', '$strMobilePhone', '$strPhoneNumber', '$strIsLicensed', '$strLicenses', '$strStreetAddress', '$strCity', '$strState', '$strPostalCode', '$strOffice', '$strValidationStatus', '$strOverallProvisioningStatus','$strAlternateEmailAddresses','$strAlternateMobilePhones','$strAlternativeSecurityIds','$strBlockCredential','$strFax','$strIsBlackberryUser','$strLastDirSyncTime','$strLastPasswordChangeTimestamp','$strLicenseReconciliationNeeded','$strMSExchRecipientTypeDetails','$strPasswordNeverExpires','$strServiceInformation','$strSignInName','$strSoftDeletionTimestamp','$strStrongPasswordRequired','$strUserLandingPageIdentifierForO365Shell','$strUserType','$strWhenCreated')"
              }
	      $i ++   
	}


	$objSkus = Get-MsolAccountSku
	Write-Output ";DELETE FROM `plugin_sw_office365forlabtech_account_sku` WHERE ClientID = $ClientID ;INSERT IGNORE into `plugin_sw_office365forlabtech_account_sku` (`ClientID`,`AccountSkuId`, `ActiveUnits`, `WarningUnits`, `ConsumedUnits`) Values  "
	$i = 0
	#Iterate through all Sku	
	Foreach ($objSku in $objSkus){	
		$strAccountSkuId = $objSku.AccountSkuId
		$strActiveUnits = $objSku.ActiveUnits
		$strWarningUnits = $objSku.WarningUnits		
		$strConsumedUnits = $objSku.ConsumedUnits		
              if($i -eq 0){
		Write-Output "($ClientID, '$strAccountSkuId', '$strActiveUnits', '$strWarningUnits', '$strConsumedUnits')"
              }else{
		Write-Output ",($ClientID, '$strAccountSkuId', '$strActiveUnits', '$strWarningUnits', '$strConsumedUnits')"
              }
	      $i ++  
	}

	$i = 0
	Write-Output ";DELETE FROM `plugin_sw_office365forlabtech_account_serviceplans` WHERE ClientID = $ClientID ;INSERT IGNORE into `plugin_sw_office365forlabtech_account_serviceplans` (`ClientID`,`AccountSkuId`, `ServicePlan`, `Status`) Values  "
    Foreach ($objSku in $objSkus){
		$strAccountSkuId = $objSku.AccountSkuId
		$objSPs = (Get-MsolAccountSku | where {$_.AccountSkuId -eq $objSku.AccountSkuId}).ServiceStatus 
		Foreach ($objSP in $objSPs){
				$myServicePlan = $objSP.ServicePlan.ServiceName
				$myStatus = $objSP.ProvisioningStatus
				
                if($i -eq 0){
					Write-Output "($ClientID, '$strAccountSkuId', '$myServicePlan', '$myStatus')"
                }else{
					Write-Output ",($ClientID,'$strAccountSkuId', '$myServicePlan', '$myStatus')"
                }
	            $i ++
		  }  
	}

# Get Users ServicePlans
	$i = 0
	Write-Output ";DELETE FROM `plugin_sw_office365forlabtech_user_serviceplans` WHERE ClientID = $ClientID ;INSERT IGNORE into `plugin_sw_office365forlabtech_user_serviceplans` (`ClientID`,`UserID`, `ServicePlan`, `Status`,`Type`,`Class`,`ServicePlanID`,`AccountSkuId`) Values  "
	Foreach ($objUser in $objUsers)
	{
		$strUserPrincipalName = $objUser.UserPrincipalName -replace "'","\'"
		$Licenses = $objUser.Licenses
        #Write-Output $strUserPrincipalName
        if($Licenses.Count -gt 0){
		    foreach ($SP in $Licenses){
                    $objUserSPs = $SP.ServiceStatus
                Foreach ($objUserSP in $objUserSPs){
				    $userServicePlan = $objUserSP.ServicePlan.ServiceName
                    $userType = $objUserSP.ServicePlan.ServiceType
                    $userClass = $objUserSP.ServicePlan.TargetClass
                    $userPlanID = $objUserSP.ServicePlan.ServicePlanId
				    $userStatus = $objUserSP.ProvisioningStatus
				    $userSKU = $Licenses.AccountSkuId
                    if($i -eq 0){
					    Write-Output "($ClientID, '$strUserPrincipalName', '$userServicePlan', '$userStatus','$userType','$userClass','$userPlanID','$userSKU')"
                    }else{
					    Write-Output ",($ClientID, '$strUserPrincipalName', '$userServicePlan', '$userStatus','$userType','$userClass','$userPlanID','$userSKU')"
                    }
	                $i ++
		        }  

            }
        }     
	}

	$obj = Get-MsolCompanyInformation
	$DisplayName = $obj.DisplayName.Replace("'","''")
	$Street = $obj.Street
	$City = $obj.City
	$State = $obj.State
	$PostalCode = $obj.PostalCode
	$CountryCode = $obj.CountryCode
	$Phone = $obj.Phone
	$MarketingNotificationEmails = $obj.MarketingNotificationEmails
	$TechnicalNotificationEmails = $obj.TechnicalNotificationEmails
	$SelfServePasswordResetEnabled = $obj.SelfServePasswordResetEnabled
	$UsersPermissionToCreateGroupsEnabled = $obj.UsersPermissionToCreateGroupsEnabled
	$UsersPermissionToCreateLOBAppsEnabled = $obj.UsersPermissionToCreateLOBAppsEnabled
	$UsersPermissionToReadOtherUsersEnabled = $obj.UsersPermissionToReadOtherUsersEnabled
	$UsersPermissionToUserConsentToAppEnabled = $obj.UsersPermissionToUserConsentToAppEnabled
	$DirectorySynchronizationEnabled = $obj.DirectorySynchronizationEnabled
	$LastDirSyncTime = $obj.LastDirSyncTime
	$LastPasswordSyncTime = $obj.LastPasswordSyncTime
	$PasswordSynchronizationEnabled = $obj.PasswordSynchronizationEnabled
	Write-Output ";DELETE FROM `plugin_sw_office365forlabtech_company` WHERE ClientID = $ClientID ;INSERT IGNORE INTO `plugin_sw_office365forlabtech_company`(`ClientID`,`DisplayName`,`Street`,`City`,`State`,`PostalCode`,`CountryCode`,`Phone`,`MarketingNotificationEmails`,`TechnicalNotificationEmails`,`SelfServePasswordResetEnabled`,`UsersPermissionToCreateGroupsEnabled`,`UsersPermissionToCreateLOBAppsEnabled`,`UsersPermissionToReadOtherUsersEnabled`,`UsersPermissionToUserConsentToAppEnabled`,`DirectorySynchronizationEnabled`,`LastDirSyncTime`,`LastPasswordSyncTime`,`PasswordSynchronizationEnabled`) VALUES "
	Write-Output "($ClientID, '$DisplayName', '$Street', '$City', '$State', '$PostalCode','$CountryCode','$Phone','$MarketingNotificationEmails','$TechnicalNotificationEmails', '$SelfServePasswordResetEnabled','$UsersPermissionToCreateGroupsEnabled','$UsersPermissionToCreateLOBAppsEnabled','$UsersPermissionToReadOtherUsersEnabled','$UsersPermissionToUserConsentToAppEnabled','$DirectorySynchronizationEnabled','$LastDirSyncTime','$LastPasswordSyncTime', '$PasswordSynchronizationEnabled')"


 Get-PSSession | Remove-PSSession
}

function ConnectTo-ExchangeOnline
{   
	Param( 
		[Parameter(
		Mandatory=$true,
		Position=0)]
		[String]$Office365AdminUsername,
		[Parameter(
		Mandatory=$true,
		Position=1)]
		[String]$Office365AdminPassword

    )
	$SecureOffice365Password = ConvertTo-SecureString -AsPlainText $Office365AdminPassword -Force    
	$Office365Credentials  = New-Object System.Management.Automation.PSCredential $Office365AdminUsername, $SecureOffice365Password
	$Session = New-PSSession -ConfigurationName Microsoft.Exchange -ConnectionUri https://ps.outlook.com/powershell -Credential $Office365credentials -Authentication Basic -AllowRedirection  -ea silentlyContinue -WarningAction silentlyContinue
	Import-PSSession $Session -AllowClobber | Out-Null
}

. Main
